//------------------------------------------------------------------------------
// ObjectPatch.pov
//
// A version of Mike Williams's Object.pov from his Isosurface Tutorial page,
// located at http://www.econym.demon.co.uk/isotut/index.htm, modified to
// use the technique ecapsulated in the ObjectAsIso.inc include file.
//
// Note! This file uses a patched version of POVRay where the object_pattern
// source code has been modified to implement the technique. This file
// won't run correctly without the code patch or some editing to use
// ObjectAsIso.inc
//                                                               WFP 09/12/09
//------------------------------------------------------------------------------

camera { location  <3, 0.9,-5> look_at <0, 0, 0> angle 35}

sky_sphere { pigment {
    function{abs(y)}
    color_map { [0.0 color blue 0.6] [1.0 color rgb 1] }
  }
}

light_source {<-100, 200,-100> colour rgb 1.0}
light_source {< 100,-200, 100> colour rgb 0.2}

// ----------------------------------------

#include "functions.inc"

   #declare Thing =
     difference {
       box {-1,1}
       sphere {0,1.2}
     }

// #declare Thing = object { cylinder { <-0.5, -0.5, -0.5>, <0.5, 0.5, 0.5>, 0.3 } }

   #declare ObjectAsIso = function{pattern{object {Thing}}}

   #declare fn_Leopard=function{pigment{leopard
      colour_map{[0.0  rgb 0.0]
                 [0.2  rgb 0.0]
                 [1.0  rgb 1.0]}
   }}

   #declare fn_CracklePigment=function {
       pigment {
         crackle
         color_map {
           [0 color rgb 0]
           [1 color rgb 1]
         }
       }
     }

   object {
        isosurface{
        //function{f_sphere(x,y,z,1.0)             +(f_noise3d(30*x,30*y,30*z)/20)}
        //function{f_sphere(x,y,z,1.0)             +(fn_CracklePigment(20*x,20*y,20*z).gray*0.1)}
        //function{f_sphere(x,y,z,1.0)             +(fn_Leopard(25*x,25*y,25*z).red*0.5)}
        //function{0.100-ObjectAsIso(x,y,z)        }
        //function{0.100-ObjectAsIso(x,y,z)        +(f_noise3d(30*x,30*y,30*z)/5)               }
          function{0.100-ObjectAsIso(x,y,z)        +(fn_CracklePigment(20*x,20*y,20*z).gray*0.2) + (f_noise3d(50*x,50*y,50*z)/10)}
        //function{0.100-ObjectAsIso(x,y,z)        +(fn_Leopard(25*x,25*y,25*z).red*0.4) + (f_noise3d(50*x,50*y,50*z)/5)}
          accuracy     0.0001
          max_gradient 22
          all_intersections
          contained_by {box{-1.1,1.1}}
        }
     pigment {rgb 0.9}
     finish {phong 0.5 phong_size 10}
   }

